Bug 552999 - Review Request: curblaster - NCurses sidescroller, with gameplay loosely based on some others.
Summary: Review Request: curblaster - NCurses sidescroller, with gameplay loosely base...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Andrea Musuruane
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-01-06 19:18 UTC by Gwyn Ciesla
Modified: 2010-03-25 22:37 UTC (History)
4 users (show)

Fixed In Version: curblaster-1.04-1.fc12
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-03-25 22:27:20 UTC
musuruan: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Gwyn Ciesla 2010-01-06 19:18:13 UTC
Grab pods and drop them in the gate, while fighting enemies in your way.
Written in C++/nCurses, with SDL_mixer for sound.

SPEC: http://zanoni.jcomserv.net/fedora/curfender/curfender.spec
SRPM: http://zanoni.jcomserv.net/fedora/curfender/curfender-1.0-1.fc12.src.rpm

Comment 1 Jason Tibbitts 2010-01-07 01:27:45 UTC
"Defender" is still trademarked (about a million different ways, of course, but I believe I found the trademark specific to the video game).   We can't call something a "clone of Defender".

http://tess2.uspto.gov/bin/showfield?f=doc&state=4009:77oh7l.9.122

Blocking FE-Legal.

Comment 2 Andrea Musuruane 2010-01-07 09:44:15 UTC
I had a quick glance at the SPEC file and I found some problems:

* "Requires: hicolor-icon-theme" is required because you install icons in %{_datadir}/icons/hicolor/*

* For new packages, do not apply a vendor tag to desktop files:
https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files

* You mixed macro styles. You used both %{buildroot} and $RPM_BUILD_ROOT:
https://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS

* You didn't use the name macro in Source0 but you used the version macro. Please be consistent and use both:
https://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS

Comment 3 Gwyn Ciesla 2010-01-07 14:12:32 UTC
New release and update that I believe addresses the above.

SPEC: http://zanoni.jcomserv.net/fedora/curfender/curfender.spec
SRPM: http://zanoni.jcomserv.net/fedora/curfender/curfender-1.01-1.fc12.src.rpm

Comment 4 Tom "spot" Callaway 2010-01-15 15:25:02 UTC
Name is infringing upon the "Defender" trademark, because it is too similar. 

You should rename it to something unique. Leaving FE-Legal block.

Comment 5 Gwyn Ciesla 2010-01-15 15:41:25 UTC
Drat.  I was afraid you'd say that. :)  I started writing this nearly 4 years ago, before I was as up-to-speed on these issues as I am now.  I'll have to re-do the ASCII title screen and everything.

Won't take me long, I'll post back here when I get it done.

Comment 6 Gwyn Ciesla 2010-01-15 15:48:35 UTC
Before I go too far, how's curblaster?  Google turns up nada.

Comment 7 Tom "spot" Callaway 2010-01-15 15:56:12 UTC
That's fine.

Comment 9 Tom "spot" Callaway 2010-01-25 15:54:51 UTC
Lifting FE-Legal.

Comment 10 Gwyn Ciesla 2010-01-25 16:14:08 UTC
Thanks!

<golf clap>

Comment 11 Andrea Musuruane 2010-03-13 16:14:47 UTC
Here is the review:

 +:ok, =:needs attention, -:needs fixing, /: not applicable

MUST Items:
[-] MUST: rpmlint must be run on every package.

$ rpmlint /home/andrea/rpmbuild/SRPMS/curblaster-1.02-1.fc12.src.rpm
curblaster.src: W: spelling-error Summary(en_US) NCurses -> N Curses, Nurses, Curses
curblaster.src: W: spelling-error Summary(en_US) sidescroller -> sidestroke, steamroller, sidesaddle
curblaster.src: W: spelling-error Summary(en_US) gameplay -> game play, game-play, nameplate
curblaster.src: W: spelling-error %description -l en_US nCurses -> n Curses, nurses, curses
1 packages and 0 specfiles checked; 0 errors, 4 warnings.
[andrea@panoramix SPECS]$ rpmlint /home/andrea/rpmbuild/RPMS/x86_64/curblaster-1.02-1.fc12.x86_64.rpm
curblaster.x86_64: W: spelling-error Summary(en_US) NCurses -> N Curses, Nurses, Curses
curblaster.x86_64: W: spelling-error Summary(en_US) sidescroller -> sidestroke, steamroller, sidesaddle
curblaster.x86_64: W: spelling-error Summary(en_US) gameplay -> game play, game-play, nameplate
curblaster.x86_64: W: spelling-error %description -l en_US nCurses -> n Curses, nurses, curses
1 packages and 0 specfiles checked; 0 errors, 4 warnings.
[andrea@panoramix SPECS]$ rpmlint /home/andrea/rpmbuild/RPMS/x86_64/curblaster-debuginfo-1.02-1.fc12.x86_64.rpm
curblaster-debuginfo.x86_64: W: invalid-url URL: http://doc.jcomserv.net/index.php/Curblaster <urlopen error timed out>
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}
[-] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.

064e811c26bff87b260bbd470e70215c71e2f8bc  curblaster-1.02.tar.gz
064e811c26bff87b260bbd470e70215c71e2f8bc  ../SOURCES/curblaster-1.02.tar.gz

[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.

Tested on F-12/x86_64

[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro.
[/] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[-] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissible content. This is described in detail in the code vs. content section of Packaging Guidelines.
[/] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[/] MUST: Header files must be in a -devel package.
[/] MUST: Static libraries must be in a -static package.
[/] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[/] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[/] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[/] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[-] SHOULD: The reviewer should test that the package builds in mock.
[-] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described.
[-] SHOULD: If scriptlets are used, those scriptlets must be sane.
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[-] SHOULD: Packages should try to preserve timestamps of original installed files.

Issues:

1. Upstream URL seems invalid. Since you are upstream, please fix :-)

2. Macro style is still inconsistent. You cannot use %{buildroot} and $RPM_OPT_FLAGS in the same spec file. Use one style and use it consistently. For example, change $RPM_OPT_FLAGS to %{optflags}.

https://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS

3. Whenever possible, use 

make %{?_smp_mflags}

If this package cannot be compiled with %{?_smp_mflags}, please add a comment stating it.

https://fedoraproject.org/wiki/Packaging:Guidelines#Parallel_make

4. Does not build in mock devel/x86_64.

[..]
g++ -o curblaster main.o check_collision.o age_bullet.o gravitize.o radar_plot.o
 object_out.o motion.o init.o draw.o powerup.o play_sound_effect.o mishaps.o ene
my_shoot.o -lncurses -lSDL_mixer
/usr/bin/ld: main.o: undefined reference to symbol 'SDL_RWFromFile'
/usr/bin/ld: note: 'SDL_RWFromFile' is defined in DSO /usr/lib64/libSDL-1.2.so.0
 so try adding it to the linker command line
/usr/lib64/libSDL-1.2.so.0: could not read symbols: Invalid operation
[..]

More info here:
https://fedoraproject.org/wiki/Features/ChangeInImplicitDSOLinking

5. Compile output is suppressed. In this way you cannot check if the program is compiled using $RPM_OPT_FLAGS. Please patch makefile to show the output.

6. Icon cache scriptlets are not the same as the ones in the guidelines:

https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache

7. When adding file copying commands in the spec file, consider using a command that preserves the files' timestamps, eg. cp -p or install -p. 

https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps

8. Description can be improved. "Written in C++/nCurses, with SDL_mixer for sound." is not really interesting for the end user. The same applies for the Summary.


NEEDSWORK

Comment 12 Andrea Musuruane 2010-03-14 08:59:58 UTC
(In reply to comment #11)

> 5. Compile output is suppressed. In this way you cannot check if the program is
> compiled using $RPM_OPT_FLAGS. Please patch makefile to show the output.

Sorry. You are actually showing the output, but you are not using $RPM_OPT_FLAG:

g++ -g -c main.cpp
g++ -g -c check_collision.cpp	
g++ -g -c age_bullet.cpp		
g++ -g -c gravitize.cpp
g++ -g -c radar_plot.cpp	
g++ -g -c object_out.cpp		
g++ -g -c motion.cpp		
g++ -g -c init.cpp		
g++ -g -c draw.cpp			
g++ -g -c powerup.cpp					
g++ -g -c play_sound_effect.cpp						
g++ -g -c mishaps.cpp						
g++ -g -c enemy_shoot.cpp

Comment 13 Gwyn Ciesla 2010-03-16 18:33:44 UTC
Thanks for the review!

1. The URL is valid, but my webserver is slow and somewhat underpowered. :)

2. Fixed.

3. Fixed.

4. Fixed and incorporated into upstream.

5. See #12.

6. Fixed.

7. Fixed.

8. Fixed, I think.

SPEC: http://zanoni.jcomserv.net/fedora/curblaster/curblaster.spec
SRPM:
http://zanoni.jcomserv.net/fedora/curblaster/curblaster-1.03-1.fc12.src.rpm

Comment 14 Andrea Musuruane 2010-03-17 22:37:49 UTC
Jon, we are almost done. Everything seems fine except a little glitch in the upstream Makefile. And since you are upstream you have the privilege to fix it instead of patching it :-)

$RPM_OPT_FLAGS are passed correctly but you are also using some fixed flag in the Makefile, as in the following example:

        $(CXX) -g -c main.cpp
              ^^^^

The "-g" parameters is fixed and cannot be taken out or changed.

I suggest you do something like the following. At the beginning of your Makefile declare the CFLAGS you "upstream" want to use. E.g.:

CFLAGS = -g

This variable will be overwritten if it is passed in the make invocation, like you are already doing in the spec file.

Then call the compiler as in this example:

        $(CXX) $(CFLAGS) -c main.cpp

In this way you have complete control of the flags, i.e. for both "upstream" and "downstream".

HTH!

Comment 16 Andrea Musuruane 2010-03-20 15:18:29 UTC
Package is now fine for me. Good job!

ACCEPT

Comment 17 Gwyn Ciesla 2010-03-22 14:08:54 UTC
Fantastic, thank you!

New Package CVS Request
=======================
Package Name: curblaster
Short Description: NCurses sidescroller, with gameplay loosely based on some others.
Owners: limb 
Branches: F-13 F-12 F-11
InitialCC:

Comment 18 Kevin Fenzi 2010-03-24 03:21:04 UTC
CVS done (by process-cvs-requests.py).

Comment 19 Fedora Update System 2010-03-24 13:28:07 UTC
curblaster-1.04-1.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/curblaster-1.04-1.fc12

Comment 20 Fedora Update System 2010-03-24 13:28:14 UTC
curblaster-1.04-1.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/curblaster-1.04-1.fc13

Comment 21 Fedora Update System 2010-03-24 13:28:19 UTC
curblaster-1.04-1.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/curblaster-1.04-1.fc11

Comment 22 Gwyn Ciesla 2010-03-24 13:29:06 UTC
Imported and built, thanks!

Comment 23 Fedora Update System 2010-03-25 22:27:13 UTC
curblaster-1.04-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 24 Fedora Update System 2010-03-25 22:33:25 UTC
curblaster-1.04-1.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 25 Fedora Update System 2010-03-25 22:37:42 UTC
curblaster-1.04-1.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.